package org.beliaj.knots.diagram;

import java.util.List;

import javax.swing.event.ChangeListener;

/**
 * ,     
 *      .
 * 
 * @author  
 * @version 1.0
 * 
 */
public interface IKnotDiagram {

	/**
	 *  .
	 * @param x x-  
	 * @param y y-  
	 */
	IPoint addPoint(int x, int y);
	
	/**
	 *   .
	 * @param p1
	 * @param p2
	 */
	ILine connectPoints(IPoint p1, IPoint p2);
	
	/**
	 *   .
	 * @return  .
	 */
	List<IPoint> getPoints();
	
	/**
	 *   .
	 * @return  
	 */
	List<ILine> getLines();
	
	/**
	 *  .
	 * @param l  
	 */
	boolean removeLine(ILine l);
	
	/**
	 *  .
	 * @param p  
	 */
	boolean removePoint(IPoint p);
	
	/**
	 *      .
	 * @param x x-
	 * @param y y-
	 * @param epsilon ,    
	 * @return  
	 */
	IPoint findPoint(int x, int y, int epsilon);
	
	/**
	 *     .
	 * 
	 * @param x x-
	 * @param y y-
	 * @param epsilon ,    
	 * @return  
	 */
	ILine findLine(int x, int y, int epsilon);
	/**
	 *     .
	 * @param x x-
	 * @param y y-
	 * @param epsilon 
	 * @return  
	 */
	IIntersection findIntersection(int x, int y, int epsilon);
	/**
	 *      .
	 * @param coeff  
	 */
	void resize(double coeff);
	/**
	 *   .
	 * @param line1  
	 * @param line2  
	 */
	void setIntersectionType(ILine line1, ILine line2);
	/**
	 *   .
	 * @param dcl 
	 */
	void addChangeListener(ChangeListener dcl);
	/**
	 *  .
	 * @param point 
	 * @param i  x-
	 * @param j  y-
	 */
	void movePoint(IPoint point, int i, int j);
	/**
	 *    x.
	 * @return    x
	 */
	int getMinXCoordinate();
	/**
	 *    y.
	 * @return    y.
	 */
	int getMinYCoordinate();
	/**
	 *    y.
	 * @return    y
	 */
	int getMaxYCoordinate();
	/**
	 *    x
	 * @return    x
	 */
	int getMaxXCoordinate();
	/**
	 *   .
	 * @param intersection 
	 * @return
	 */
	boolean swapLines(IIntersection intersection);
	/**
	 *   .
	 * @param line   
	 */
	void changeLineDirection(ILine line);
	/**
	 *   .
	 * @return   
	 */
	boolean isComplete();
}
