package org.beliaj.knots.diagram.impl;

import org.beliaj.knots.diagram.IIntersection;
import org.beliaj.knots.diagram.ILine;

/**
 *  .
 * 
 * @author  
 * @version 1.1
 */
class Intersection implements IIntersection{

	final String myName;
	
	/**
	 *  .
	 */
	private Line myUpLine;
	
	/**
	 *  .
	 */
	private Line myDownLine;
	
	/**
	 *     .
	 * @param line1  
	 * @param line2  
	 */
	Intersection(ILine iline1, ILine iline2, int count){
		Line line1 = (Line)iline1;
		Line line2 = (Line)iline2;
		/*if (!Intersection.checkLinesForIntersection(line1, line2)){
			throw new InvalidIntersectionException("Your lines are: "
					+ line1 
					+ line2
					+ "They can not have an intersection.");
		}
		*/
		this.myName = "I" + count;
		line1.getIntersectionsList().add(this);
		line2.getIntersectionsList().add(this);
		
		this.myUpLine = line1;
		this.myDownLine = line2;
	}
	
	/**
	 *    .
	 */
	void swapLines(){
		Line t = this.myUpLine;
		this.myUpLine = this.myDownLine;
		this.myDownLine = t;
	}

	/**
	 *    .
	 * @return  
	 */
	public ILine getDownLine() {
		return this.myDownLine;
	}

	/**
	 *    .
	 * @return   
	 */
	public ILine getUpLine() {
		return this.myUpLine;
	}

	/**
	 *    .
	 * @param line1  
	 * @param line2  
	 * @return   
	 */ 
	public static boolean checkLinesForIntersection(ILine line1, ILine line2){
		
		/*if ( (line1.getFPoint().equals(line2.getFPoint())) 
				||(line1.getFPoint().equals(line2.getSPoint()))
				|| (line1.getSPoint().equals(line2.getFPoint()))
				|| (line1.getSPoint().equals(line2.getSPoint()))){
			return false;
		}
		
		double k1 = line1.getAngularCoefficient();
		double k2 = line2.getAngularCoefficient();
		double b1 = line1.getFreeTerm();
		double b2 = line2.getFreeTerm();
		
		//   
		if ((Math.abs(k1-k2) < 1/Double.MAX_VALUE)){
			if ((Math.abs(b1-b2) < 1/Double.MAX_VALUE)){
				return true;
			}
			return false;
		}
		
		//    
		double x = (b2-b1)/(k1-k2);
		
		return (( (line1.getFPoint().getX() - x)*(line1.getSPoint().getX() - x) < 0 ) 
				&& ( (line2.getFPoint().getX() - x)*(line2.getSPoint().getX() - x) < 0 ));
		*/
		
		int x1 = line1.getFPoint().getX();
		int x2 = line1.getSPoint().getX();
		int x3 = line2.getFPoint().getX();
		int x4 = line2.getSPoint().getX();
		
		int y1 = line1.getFPoint().getY();
		int y2 = line1.getSPoint().getY();
		int y3 = line2.getFPoint().getY();
		int y4 = line2.getSPoint().getY();
		
		
		double d = ((x1-x2)*(y4-y3) - (x4-x3)*(y1-y2));
		
		if (((x4-x2) == 0) && ((y4-y2) == 0)){
			//System.out.println(line1 + "\n" + line2 + "\n" + "x4 "+ x4 + " x2 " + x2 + " y4 " + " y2 " + y2);
			return false;
		}
		
		if (d == 0){
			//System.out.println(line1 + "\n" + line2 + "\n" + " d " + d);
			return false;
		}
		
		double alpha = ((x4-x2)*(y4-y3) - (x4-x3)*(y4-y2))/d;
		
		double beta = ((x1-x2)*(y4-y2) - (x4-x2)*(y1-y2))/d;
		
		//System.out.println(line1 + "\n" + line2 + "\n" + " d " + d + " alpha "+ alpha + " beta "+ beta);
		
		return ((alpha < 1) && (alpha > 0) && (beta < 1) && (beta > 0));
		
	}
	
	public String toString(){
		return this.myName +  " ( " + this.myUpLine.myName + ", " + this.myDownLine.myName + " )";
	}
	
	public static class InvalidIntersectionException extends RuntimeException{
		
		private static final long serialVersionUID = 1L;

		public InvalidIntersectionException(String message){
			super(message);
		}
		
	}

	public double[] getPosition() {
		
		Line line1 = this.myDownLine;
		Line line2 = this.myUpLine;
		
		int x1 = line1.getFPoint().getX();
		int x2 = line1.getSPoint().getX();
		int x3 = line2.getFPoint().getX();
		int x4 = line2.getSPoint().getX();
		
		int y1 = line1.getFPoint().getY();
		int y2 = line1.getSPoint().getY();
		int y3 = line2.getFPoint().getY();
		int y4 = line2.getSPoint().getY();
		
		
		double d = ((x1-x2)*(y4-y3) - (x4-x3)*(y1-y2));
		double alpha = ((x4-x2)*(y4-y3) - (x4-x3)*(y4-y2))/d;
		
		double[] r = new double[2];
		r[0] = alpha*x1 + (1-alpha)*x2;
		r[1] = alpha*y1 + (1-alpha)*y2;
		
		return r;
	}
	
}