package org.beliaj.knots.diagram.impl;

import java.util.*;

import org.beliaj.knots.diagram.IIntersection;
import org.beliaj.knots.diagram.ILine;
import org.beliaj.knots.diagram.IPoint;

/**
 *  .
 */
class Line implements ILine{
	
	final String myName;
	
	/**
	 *  .
	 */
	private Point myFPoint;
	
	/**
	 *  .
	 */
	private Point mySPoint;
	
	/**
	 *  .
	 */
	private ArrayList<IIntersection> myIntersectionsList = new ArrayList<IIntersection>();
	
	public List<IIntersection> getIntersections(){
		return Collections.unmodifiableList(this.myIntersectionsList);
	}

	List<IIntersection> getIntersectionsList(){
		return this.myIntersectionsList;
	}
	
	/**
	 *   .
	 * @return   
	 */
	public IPoint getFPoint() {
		return myFPoint;
	}

	/**
	 *   .
	 * @param fPoint  
	 */
	private void setFPoint(Point fPoint) {
		this.myFPoint = fPoint;
	}

	/**
	 *   .
	 * @return  
	 */
	public IPoint getSPoint() {
		return mySPoint;
	}
	
	/**
	 *  equals.  ,    .
	 */
	public boolean equals(Object obj){
		if (! (obj instanceof  Line)){
			return false;
		}
		
		Line line = (Line)obj;
		
		//   
		//  - 
		return (this.getFPoint().equals( line.getFPoint() ) && 
				this.getSPoint().equals( line.getSPoint() )) 
				|| (this.getSPoint().equals( line.getFPoint() ) && 
					this.getFPoint().equals( line.getSPoint() ));
	}

	/**
	 *   .
	 * @param sPoint  
	 */
	private void setSPoint(Point sPoint) {
		this.mySPoint = sPoint;
	}
	
	/**
	 *     .
	 * @param spoint  
	 * @param fpoint  
	 */
	Line(Point spoint, Point fpoint, int count){
		if (spoint.equals(fpoint)){
			throw new PointException("Your points ( " +
					spoint.getX() + ", " + spoint.getY() +
					" ) and ( " +
					fpoint.getX() + ", " + fpoint.getY() +
					" are identical");
		}
		this.myName = "L" + count; 
		this.myFPoint = fpoint;
		this.mySPoint = spoint;
		
		//       
		this.myFPoint.assignLine(this);
		try{
			this.mySPoint.assignLine(this);
		} catch (LineException le){
			this.myFPoint.removeLine(this);
			throw le;
		}
	}
	
	/**
	 *    .
	 * @param intrs 
	 */
	private void addIntersection(Intersection intrs){
		this.myIntersectionsList.add(intrs);
	}
	
	public String toString(){
		StringBuffer sb = new StringBuffer();
		sb.append(this.myName + ": ( " + this.myFPoint.myName + ", " + this.mySPoint.myName + " )");
		
		if (this.myIntersectionsList.size() > 0){
			ListIterator<IIntersection> it = this.myIntersectionsList.listIterator();
			sb.append('\n'+ "    ");
			while (it.hasNext()){
				sb.append(((Intersection)it.next()).myName);
				sb.append(" ");
			}
		}
		
		return sb.toString();
	}

	public void changeDirection() {
		Point p = this.myFPoint;
		this.myFPoint = this.mySPoint;
		this.mySPoint = p;
	}
	
	
	
}