package org.beliaj.knots.painters.impl;

import java.awt.event.MouseEvent;

import javax.swing.event.ChangeEvent;

import org.beliaj.knots.diagram.ILine;
import org.beliaj.knots.painters.IEnum;
import org.beliaj.knots.painters.Actor;

public class DirActor extends Actor {
	
	private PaintDiagramClient client;
	private ILine myCurrentLine;

	DirActor(PaintDiagramClient client) {
		this.client = client;
	}

	@Override
	public boolean isActionPossible() {
		return ((this.client.myDiagram.getLines().size() > 0) && this.client.hasDirections());
	}

	@Override
	public IEnum getActionCode() {
		return ActionEnum.SHANGE_DIRECTION;
	}
	
	public void mouseMoved(MouseEvent e) {
		
		this.myCurrentLine = null;
		this.client.mySelectedLines.clear();
		this.client.mySelectedPoints.clear();
		
		ILine line = this.client.myDiagram.findLine(this.client.fromRealXToOur(e.getX()),
				this.client.fromRealYToOur(e.getY()),
				2*this.client.myPointDiam);
			
		if (line != null){
			this.myCurrentLine = line;
			this.client.mySelectedLines.add(line);
			this.client.mySelectedPoints.add(line.getSPoint());
			this.client.mySelectedPoints.add(line.getFPoint());
			ILine line1 = this.nextLine(line); 
			while ((line1 != null) && (line1 != line)){
				this.client.mySelectedLines.add(line1);
				this.client.mySelectedPoints.add(line1.getSPoint());
				line1 = this.nextLine(line1);
			}
			
			line1 = this.previousLine(line); 
			while ((line1 != null) && (line1 != line)){
				this.client.mySelectedLines.add(line1);
				this.client.mySelectedPoints.add(line1.getFPoint());
				line1 = this.previousLine(line1);
			}
		} 
		e.getComponent().repaint();
	}

	public void mousePressed(MouseEvent e) {
		if (this.myCurrentLine != null){
			this.client.myDiagram.changeLineDirection(this.myCurrentLine);
			this.myCurrentLine = null;
		}
		e.getComponent().repaint();
	}
	
	public void mouseReleased(MouseEvent e) {
		this.myCurrentLine = null;
		this.client.mySelectedLines.clear();
		this.client.mySelectedPoints.clear();
		
		ILine line = this.client.myDiagram.findLine(this.client.fromRealXToOur(e.getX()),
				this.client.fromRealYToOur(e.getY()),
				2*this.client.myPointDiam);
			
		if (line != null){
			this.myCurrentLine = line;
			this.client.mySelectedLines.add(line);
			this.client.mySelectedPoints.add(line.getSPoint());
			this.client.mySelectedPoints.add(line.getFPoint());
			ILine line1 = this.nextLine(line); 
			while ((line1 != null) && (line1 != line)){
				this.client.mySelectedLines.add(line1);
				this.client.mySelectedPoints.add(line1.getSPoint());
				line1 = this.nextLine(line1);
			}
			
			line1 = this.previousLine(line); 
			while ((line1 != null) && (line1 != line)){
				this.client.mySelectedLines.add(line1);
				this.client.mySelectedPoints.add(line1.getFPoint());
				line1 = this.previousLine(line1);
			}
		} 
		e.getComponent().repaint();
	}
	
	private ILine nextLine(ILine line){
		ILine line1;
		if (line.getSPoint().getLine().size() == 1){
			return null;
		}
		if (line.getSPoint().getLine().get(0)==line){
			line1 = line.getSPoint().getLine().get(1);
		} else {
			line1 = line.getSPoint().getLine().get(0);
		}
		
		return line1;
	}
	
	private ILine previousLine(ILine line){
		ILine line1;
		if (line.getFPoint().getLine().size() == 1){
			return null;
		}
		if (line.getFPoint().getLine().get(0) == line){
			line1 = line.getFPoint().getLine().get(1);
		} else {
			line1 = line.getFPoint().getLine().get(0);
		}
		
		return line1;
	}

}
