package org.beliaj.knots.painters.impl;

import java.awt.event.MouseEvent;

import javax.swing.event.ChangeEvent;

import org.beliaj.knots.diagram.IPoint;
import org.beliaj.knots.painters.IEnum;
import org.beliaj.knots.painters.Actor;

public class MoveActor extends Actor {

	/**
	 * 
	 */
	private final PaintDiagramClient client;
	private IPoint myCurrentPoint;

	/**
	 * @param client
	 */
	MoveActor(PaintDiagramClient client) {
		this.client = client;
	}
	
	public void mouseMoved(MouseEvent e) {
		IPoint point = this.client.myDiagram.findPoint(this.client.fromRealXToOur(e.getX()),
				this.client.fromRealYToOur(e.getY()),
				this.client.myPointDiam);
		
		if (point != null){
			this.client.mySelectedPoints.clear();
			this.client.mySelectedPoints.add(point);
			this.myCurrentPoint = point;
		} else {
			this.myCurrentPoint = null;
			this.client.mySelectedPoints.clear();
		}
		e.getComponent().repaint();
	}
	
	public void mouseDragged(MouseEvent e) {
		
		int x = e.getX();
		int y = e.getY();
		
		if (e.getComponent().getHeight() - this.client.myPointDiam < e.getY()){
			y = e.getComponent().getHeight() - this.client.myPointDiam;
		}
		
		if (e.getComponent().getWidth() - this.client.myPointDiam < e.getX()){
			x = e.getComponent().getWidth() - this.client.myPointDiam;
		}
		
		if (e.getY() < this.client.myPointDiam){
			y = this.client.myPointDiam;
		}
		
		if (e.getX() < this.client.myPointDiam){
			x = this.client.myPointDiam;
		}
		
		if (this.myCurrentPoint != null){
			this.client.myDiagram.movePoint(this.myCurrentPoint,
				this.client.fromRealXToOur(x),
				this.client.fromRealYToOur(y));
		}
		
		e.getComponent().repaint();
	}

	@Override
	public boolean isActionPossible() {
		return (this.client.myDiagram.getPoints().size() > 0);
	}

	@Override
	public IEnum getActionCode() {
		return ActionEnum.MOVE;
	}
	
}
